//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <math.h>
#include <stdlib.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "hlLEDArray1_3Impl"
#pragma link "hlLEDArray1_3"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   //Randomize LEDs on Tabsheet 1
   RandomizeBtnClick(this);

   //Initialize LEDs on Tabsheet 2
   ProgressLED->State[0][0] = 1;
   ProgressLED->State[1][0] = 1;
   ProgressLED->State[2][0] = 1;
   ProgressLED->State[8][0] = 2;
   ProgressLED->State[9][0] = 2;
   ProgressLED->State[10][0] = 2;

   ProgressLED2->State[0][0] = 1;
   ProgressLED2->State[1][0] = 2;
   ProgressLED2->State[2][0] = 3;
   ProgressLED2->State[3][0] = 4;

   ProgressLED3->State[0][0] = 1;
   ProgressLED3->State[1][1] = 1;
   ProgressLED3->State[2][2] = 1;
   ProgressLED3->State[3][3] = 1;
   ProgressLED3->State[4][4] = 1;
   ProgressLED3->State[3][5] = 1;
   ProgressLED3->State[2][6] = 1;
   ProgressLED3->State[1][7] = 1;
   ProgressLED3->State[0][8] = 1;

   //Initialize LEDs on Tabsheet 4
   ButtonField->Randomize();

   //Initialize LEDs on Tabsheet 5
   PictureLED->LoadFromBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
   /********* Contour Plot **************/

   if(!TabSheet3->Visible)
      return;

   //for contour plots there is a more efficient way
   //of painting. Call BeginUpdate() to suppress repeated
   //repainting. Update the entire state array then call
   //EndUpdate() to refresh the screen.

   ContourArray->BeginUpdate();

   int n = ContourArray->NumColumns;
   int m = ContourArray->NumRows;

   //This example uses self-generated data
   //for the plot
   static double zoom = 10;
   zoom += 1;
   if(zoom > 20)
      zoom = 10;

   for(int i=0; i<n; ++i)
   {
      for(int j=0; j<m; ++j)
      {
         ContourArray->State[i][j] = abs(floor(7.0*j*(sin(i*j/zoom))/m));
      }
   }

   ContourArray->EndUpdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
   /************ Scrolling LEDs *******************/

   if(!TabSheet2->Visible)
      return;
      
   ProgressLED->Scroll(-5, 0);

   ProgressLED2->Scroll(0, 1);

   ProgressLED3->Scroll(-2, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StartBtnClick(TObject *Sender)
{
   Timer3->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StopBtnClick(TObject *Sender)
{
   Timer3->Enabled = false;   
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadBmpBtnClick(TObject *Sender)
{
   /************ Load a bitmap into ThlLEDArray ***************/

   if(OpenDialog1->Execute())
   {
      Image1->Picture->LoadFromFile(OpenDialog1->FileName);
      PictureLED->LoadFromBitmap(Image1->Picture->Bitmap);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RandomizeBtnClick(TObject *Sender)
{
   //Randomize LEDs on Tabsheet 1
   StandardLED1->Randomize();
   StandardLED2->Randomize();
   StandardLED3->Randomize();
   StandardLED4->Randomize();
   StandardLED5->Randomize();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonFieldClick(TObject *Sender, int I, int J)
{
   int oldState = ButtonField->State[I][J];
   int newState = ((oldState+1)%3);

   ButtonField->State[I][J] = newState;

   Label8->Caption = AnsiString("Notification from button: ") + I + "/" + J + ". Its state has changed from " + oldState + " to " + newState;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::AddRowBtnClick(TObject *Sender)
{
   if((ButtonField->NumRows*(ButtonField->LEDHeight+ButtonField->Spacing)
      +2*(ButtonField->BorderWidth + ButtonField->BevelWidth)) < ButtonField->Height)
      ButtonField->NumRows += 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DeleteRowBtnClick(TObject *Sender)
{
   if(ButtonField->NumRows >= 0)
      ButtonField->NumRows -= 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AddColumnBtnClick(TObject *Sender)
{
   if((ButtonField->NumColumns*(ButtonField->LEDWidth+ButtonField->Spacing)
      +2*(ButtonField->BorderWidth + ButtonField->BevelWidth)) < ButtonField->Width)
      ButtonField->NumColumns += 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DeleteColumnBtnClick(TObject *Sender)
{
   if(ButtonField->NumColumns >= 0)
      ButtonField->NumColumns -= 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TabSheet4Show(TObject *Sender)
{
   //Clear the notification label of the button array
   Label8->Caption = "";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   if(!TabSheet1->Visible)
      return;
   StandardLED2->Randomize();
}
//---------------------------------------------------------------------------

